
_SetDirection:

;electronique_telecommande_002c_16f628.mpas,35 :: 		begin
;electronique_telecommande_002c_16f628.mpas,37 :: 		if bTx then
	MOVF       FARG_SetDirection_bTx+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__SetDirection2
;electronique_telecommande_002c_16f628.mpas,39 :: 		TRISA      := %11101111; // RA0..RA3 as inputs
	MOVLW      239
	MOVWF      TRISA+0
;electronique_telecommande_002c_16f628.mpas,40 :: 		TRISB      := %11111011; // RB0..RB7 as inputs, but RB2 as output
	MOVLW      251
	MOVWF      TRISB+0
;electronique_telecommande_002c_16f628.mpas,41 :: 		end
	GOTO       L__SetDirection3
;electronique_telecommande_002c_16f628.mpas,43 :: 		else begin
L__SetDirection2:
;electronique_telecommande_002c_16f628.mpas,44 :: 		TRISA      := %11100000; // RA0..RA3 as outputs
	MOVLW      224
	MOVWF      TRISA+0
;electronique_telecommande_002c_16f628.mpas,45 :: 		TRISB      := %00000010; // RB0..RB7 as outputs, but RB1 as input
	MOVLW      2
	MOVWF      TRISB+0
;electronique_telecommande_002c_16f628.mpas,46 :: 		end;
L__SetDirection3:
;electronique_telecommande_002c_16f628.mpas,47 :: 		PORTA :=   %00010000;  // clear portA, but let RA4 to high logic level (led off)
	MOVLW      16
	MOVWF      PORTA+0
;electronique_telecommande_002c_16f628.mpas,48 :: 		PORTB :=   0;  // clear portB
	CLRF       PORTB+0
;electronique_telecommande_002c_16f628.mpas,49 :: 		end;
	RETURN
; end of _SetDirection

_Init:

;electronique_telecommande_002c_16f628.mpas,52 :: 		begin
;electronique_telecommande_002c_16f628.mpas,53 :: 		CMCON := %00000111; // disable all comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_telecommande_002c_16f628.mpas,54 :: 		VRCON := 0;
	CLRF       VRCON+0
;electronique_telecommande_002c_16f628.mpas,56 :: 		OPTION_REG.NOT_RBPU := 1; // disable pullup
	BSF        OPTION_REG+0, 7
;electronique_telecommande_002c_16f628.mpas,57 :: 		OPTION_REG.T0CS := 0;  // bit 5 TMR0 Clock Source Select bit:0=Internal Clock (CLKO) / 1=Transition on T0CKI pin
	BCF        OPTION_REG+0, 5
;electronique_telecommande_002c_16f628.mpas,58 :: 		OPTION_REG.T0SE := 0;  // bit 4 TMR0 Source Edge Select bit: 0=low/high / 1=high/low
	BCF        OPTION_REG+0, 4
;electronique_telecommande_002c_16f628.mpas,59 :: 		OPTION_REG.PSA  := 1;  // bit 3 Prescaler Assignment bit: 0=Prescaler is assigned to the Timer0
	BSF        OPTION_REG+0, 3
;electronique_telecommande_002c_16f628.mpas,60 :: 		OPTION_REG.PS2  := 0;  // bits 2-0  PS2:PS0: Prescaler Rate Select bits
	BCF        OPTION_REG+0, 2
;electronique_telecommande_002c_16f628.mpas,61 :: 		OPTION_REG.PS1  := 0;
	BCF        OPTION_REG+0, 1
;electronique_telecommande_002c_16f628.mpas,62 :: 		OPTION_REG.PS0  := 0;
	BCF        OPTION_REG+0, 0
;electronique_telecommande_002c_16f628.mpas,64 :: 		INTCON.GIE  := 1;  // enable global int
	BSF        INTCON+0, 7
;electronique_telecommande_002c_16f628.mpas,65 :: 		INTCON.PEIE := 1;  // enable peripheral int
	BSF        INTCON+0, 6
;electronique_telecommande_002c_16f628.mpas,66 :: 		INTCON.T0IE := 0;  // disable Timer0 int
	BCF        INTCON+0, 5
;electronique_telecommande_002c_16f628.mpas,67 :: 		INTCON.INTE := 0;  // disable RB0 int
	BCF        INTCON+0, 4
;electronique_telecommande_002c_16f628.mpas,68 :: 		INTCON.RBIE := 0;  // disable RB4..RB7 int
	BCF        INTCON+0, 3
;electronique_telecommande_002c_16f628.mpas,69 :: 		PIE1.RCIE   := 1;  // enable USART Rx int
	BSF        PIE1+0, 5
;electronique_telecommande_002c_16f628.mpas,70 :: 		PIR1.RCIF   := 0;  // reset USART Rx int flag
	BCF        PIR1+0, 5
;electronique_telecommande_002c_16f628.mpas,74 :: 		TRISA := %11101111; // RA0..RA7 as inputs
	MOVLW      239
	MOVWF      TRISA+0
;electronique_telecommande_002c_16f628.mpas,75 :: 		TRISB := %11111011; // RB0..RB7 as inputs, but RB2 (USART-TX) as output
	MOVLW      251
	MOVWF      TRISB+0
;electronique_telecommande_002c_16f628.mpas,77 :: 		PCON.OSCF := 1;  // Osc int - 4 MHz
	BSF        PCON+0, 3
;electronique_telecommande_002c_16f628.mpas,80 :: 		TXSTA.TXEN := 1;  // Tx enabled
	BSF        TXSTA+0, 5
;electronique_telecommande_002c_16f628.mpas,81 :: 		TXSTA.TX9  := 0;  // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_telecommande_002c_16f628.mpas,82 :: 		TXSTA.SYNC := 0;  // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_telecommande_002c_16f628.mpas,83 :: 		RCSTA.SPEN := 1;  // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_telecommande_002c_16f628.mpas,84 :: 		RCSTA.CREN := 1;  // enable continuous receive
	BSF        RCSTA+0, 4
;electronique_telecommande_002c_16f628.mpas,85 :: 		RCSTA.TX9  := 0;  // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_telecommande_002c_16f628.mpas,86 :: 		UART1_Init(19200); // change speed if needed
	MOVLW      38
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_telecommande_002c_16f628.mpas,88 :: 		PORTA :=   %00010000;  // clear portA, but let RA4 to high logic level (led off)
	MOVLW      16
	MOVWF      PORTA+0
;electronique_telecommande_002c_16f628.mpas,89 :: 		PORTB :=   0;  // clear portB
	CLRF       PORTB+0
;electronique_telecommande_002c_16f628.mpas,91 :: 		TxDataOld := 0;
	CLRF       _TxDataOld+0
;electronique_telecommande_002c_16f628.mpas,92 :: 		end;
	RETURN
; end of _Init

_Main_Welcome:

;electronique_telecommande_002c_16f628.mpas,95 :: 		begin
;electronique_telecommande_002c_16f628.mpas,96 :: 		ClearBit(PORTA, 4);
	BCF        PORTA+0, 4
;electronique_telecommande_002c_16f628.mpas,97 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L__Main_Welcome6:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome6
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome6
	DECFSZ     R11+0, 1
	GOTO       L__Main_Welcome6
;electronique_telecommande_002c_16f628.mpas,98 :: 		SetBit(PORTA, 4);
	BSF        PORTA+0, 4
;electronique_telecommande_002c_16f628.mpas,99 :: 		end;
	RETURN
; end of _Main_Welcome

_Data_Send:

;electronique_telecommande_002c_16f628.mpas,102 :: 		begin
;electronique_telecommande_002c_16f628.mpas,104 :: 		UART1_Write(TxData);
	MOVF       _TxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002c_16f628.mpas,105 :: 		end;
	RETURN
; end of _Data_Send

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_telecommande_002c_16f628.mpas,108 :: 		begin
;electronique_telecommande_002c_16f628.mpas,109 :: 		if TestBit(PIR1, RCIF) then
	CLRF       R0+0
	BTFSS      PIR1+0, 5
	GOTO       L__Interrupt12
	MOVLW      1
	MOVWF      R0+0
L__Interrupt12:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt10
;electronique_telecommande_002c_16f628.mpas,112 :: 		RxData := RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _RxData+0
;electronique_telecommande_002c_16f628.mpas,113 :: 		bDataReceived := true;
	MOVLW      255
	MOVWF      _bDataReceived+0
;electronique_telecommande_002c_16f628.mpas,115 :: 		if TestBit(RCSTA, OERR) then
	CLRF       R0+0
	BTFSS      RCSTA+0, 1
	GOTO       L__Interrupt16
	MOVLW      1
	MOVWF      R0+0
L__Interrupt16:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt14
;electronique_telecommande_002c_16f628.mpas,117 :: 		ClearBit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_telecommande_002c_16f628.mpas,118 :: 		SetBit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_telecommande_002c_16f628.mpas,119 :: 		end;
L__Interrupt14:
;electronique_telecommande_002c_16f628.mpas,121 :: 		end;
L__Interrupt10:
;electronique_telecommande_002c_16f628.mpas,122 :: 		end;
L__Interrupt41:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Data_Read:

;electronique_telecommande_002c_16f628.mpas,125 :: 		begin
;electronique_telecommande_002c_16f628.mpas,127 :: 		TxData.0 := IO_Data_0;
	BTFSC      RA0_bit+0, 0
	GOTO       L__Data_Read42
	BCF        _TxData+0, 0
	GOTO       L__Data_Read43
L__Data_Read42:
	BSF        _TxData+0, 0
L__Data_Read43:
;electronique_telecommande_002c_16f628.mpas,128 :: 		TxData.1 := IO_Data_1;
	BTFSC      RA1_bit+0, 1
	GOTO       L__Data_Read44
	BCF        _TxData+0, 1
	GOTO       L__Data_Read45
L__Data_Read44:
	BSF        _TxData+0, 1
L__Data_Read45:
;electronique_telecommande_002c_16f628.mpas,129 :: 		TxData.2 := IO_Data_2;
	BTFSC      RA2_bit+0, 2
	GOTO       L__Data_Read46
	BCF        _TxData+0, 2
	GOTO       L__Data_Read47
L__Data_Read46:
	BSF        _TxData+0, 2
L__Data_Read47:
;electronique_telecommande_002c_16f628.mpas,130 :: 		TxData.3 := IO_Data_3;
	BTFSC      RA3_bit+0, 3
	GOTO       L__Data_Read48
	BCF        _TxData+0, 3
	GOTO       L__Data_Read49
L__Data_Read48:
	BSF        _TxData+0, 3
L__Data_Read49:
;electronique_telecommande_002c_16f628.mpas,131 :: 		TxData.4 := IO_Data_4;
	BTFSC      RB4_bit+0, 4
	GOTO       L__Data_Read50
	BCF        _TxData+0, 4
	GOTO       L__Data_Read51
L__Data_Read50:
	BSF        _TxData+0, 4
L__Data_Read51:
;electronique_telecommande_002c_16f628.mpas,132 :: 		TxData.5 := IO_Data_5;
	BTFSC      RB5_bit+0, 5
	GOTO       L__Data_Read52
	BCF        _TxData+0, 5
	GOTO       L__Data_Read53
L__Data_Read52:
	BSF        _TxData+0, 5
L__Data_Read53:
;electronique_telecommande_002c_16f628.mpas,133 :: 		TxData.6 := IO_Data_6;
	BTFSC      RB6_bit+0, 6
	GOTO       L__Data_Read54
	BCF        _TxData+0, 6
	GOTO       L__Data_Read55
L__Data_Read54:
	BSF        _TxData+0, 6
L__Data_Read55:
;electronique_telecommande_002c_16f628.mpas,134 :: 		TxData.7 := IO_Data_7;
	BTFSC      RB7_bit+0, 7
	GOTO       L__Data_Read56
	BCF        _TxData+0, 7
	GOTO       L__Data_Read57
L__Data_Read56:
	BSF        _TxData+0, 7
L__Data_Read57:
;electronique_telecommande_002c_16f628.mpas,138 :: 		if ((In_TxMode = 0) and (TxData <> TxDataOld)) or (In_TxMode = 1) then
	BTFSC      RB0_bit+0, 0
	GOTO       L__Data_Read58
	BSF        114, 0
	GOTO       L__Data_Read59
L__Data_Read58:
	BCF        114, 0
L__Data_Read59:
	MOVF       _TxData+0, 0
	XORWF      _TxDataOld+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	CLRF       R0+0
	BTFSC      114, 0
	INCF       R0+0, 1
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	BTFSC      RB0_bit+0, 0
	GOTO       L__Data_Read60
	BCF        3, 0
	GOTO       L__Data_Read61
L__Data_Read60:
	BSF        3, 0
L__Data_Read61:
	CLRF       R0+0
	BTFSC      3, 0
	INCF       R0+0, 1
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Data_Read19
;electronique_telecommande_002c_16f628.mpas,139 :: 		Data_Send;
	CALL       _Data_Send+0
L__Data_Read19:
;electronique_telecommande_002c_16f628.mpas,140 :: 		TxDataOld := TxData;
	MOVF       _TxData+0, 0
	MOVWF      _TxDataOld+0
;electronique_telecommande_002c_16f628.mpas,141 :: 		end;
	RETURN
; end of _Data_Read

_main:

;electronique_telecommande_002c_16f628.mpas,143 :: 		begin
;electronique_telecommande_002c_16f628.mpas,144 :: 		Init;
	CALL       _Init+0
;electronique_telecommande_002c_16f628.mpas,145 :: 		bDirTx := TestBit(PORTA, 5);  // RA7 in TC 002 version
	CLRF       R0+0
	BTFSS      PORTA+0, 5
	GOTO       L__main22
	MOVLW      1
	MOVWF      R0+0
L__main22:
	MOVF       R0+0, 0
	MOVWF      _bDirTx+0
;electronique_telecommande_002c_16f628.mpas,146 :: 		SetDirection(bDirTx); // set mode as Tx or Rx, as set by RA5 state
	MOVF       R0+0, 0
	MOVWF      FARG_SetDirection_bTx+0
	CALL       _SetDirection+0
;electronique_telecommande_002c_16f628.mpas,147 :: 		bDirTxOld := bDirTx;
	MOVF       _bDirTx+0, 0
	MOVWF      _bDirTxOld+0
;electronique_telecommande_002c_16f628.mpas,148 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_telecommande_002c_16f628.mpas,150 :: 		while true do
L__main24:
;electronique_telecommande_002c_16f628.mpas,154 :: 		bDirTx := TestBit(PORTA, 5); // RA7 in TC 002 version
	CLRF       R1+0
	BTFSS      PORTA+0, 5
	GOTO       L__main28
	MOVLW      1
	MOVWF      R1+0
L__main28:
	MOVF       R1+0, 0
	MOVWF      _bDirTx+0
;electronique_telecommande_002c_16f628.mpas,155 :: 		if bDirTx <> bDirTxOld then
	MOVF       R1+0, 0
	XORWF      _bDirTxOld+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main30
;electronique_telecommande_002c_16f628.mpas,157 :: 		SetDirection(bDirTx); // set mode as Tx or Rx, as set by RA5 state
	MOVF       _bDirTx+0, 0
	MOVWF      FARG_SetDirection_bTx+0
	CALL       _SetDirection+0
;electronique_telecommande_002c_16f628.mpas,158 :: 		bDirTxOld := bDirTx;
	MOVF       _bDirTx+0, 0
	MOVWF      _bDirTxOld+0
;electronique_telecommande_002c_16f628.mpas,159 :: 		end;
L__main30:
;electronique_telecommande_002c_16f628.mpas,164 :: 		if bDirTx then
	MOVF       _bDirTx+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main33
;electronique_telecommande_002c_16f628.mpas,166 :: 		Data_Read;
	CALL       _Data_Read+0
;electronique_telecommande_002c_16f628.mpas,167 :: 		end
	GOTO       L__main34
;electronique_telecommande_002c_16f628.mpas,170 :: 		else begin
L__main33:
;electronique_telecommande_002c_16f628.mpas,171 :: 		if bDataReceived then  // int occured by receiving data on Rx pin
	MOVF       _bDataReceived+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main36
;electronique_telecommande_002c_16f628.mpas,176 :: 		IO_Data_0 := RxData.0;
	BTFSC      _RxData+0, 0
	GOTO       L__main62
	BCF        RA0_bit+0, 0
	GOTO       L__main63
L__main62:
	BSF        RA0_bit+0, 0
L__main63:
;electronique_telecommande_002c_16f628.mpas,177 :: 		IO_Data_1 := RxData.1;
	BTFSC      _RxData+0, 1
	GOTO       L__main64
	BCF        RA1_bit+0, 1
	GOTO       L__main65
L__main64:
	BSF        RA1_bit+0, 1
L__main65:
;electronique_telecommande_002c_16f628.mpas,178 :: 		IO_Data_2 := RxData.2;
	BTFSC      _RxData+0, 2
	GOTO       L__main66
	BCF        RA2_bit+0, 2
	GOTO       L__main67
L__main66:
	BSF        RA2_bit+0, 2
L__main67:
;electronique_telecommande_002c_16f628.mpas,179 :: 		IO_Data_3 := RxData.3;
	BTFSC      _RxData+0, 3
	GOTO       L__main68
	BCF        RA3_bit+0, 3
	GOTO       L__main69
L__main68:
	BSF        RA3_bit+0, 3
L__main69:
;electronique_telecommande_002c_16f628.mpas,180 :: 		IO_Data_4 := RxData.4;
	BTFSC      _RxData+0, 4
	GOTO       L__main70
	BCF        RB4_bit+0, 4
	GOTO       L__main71
L__main70:
	BSF        RB4_bit+0, 4
L__main71:
;electronique_telecommande_002c_16f628.mpas,181 :: 		IO_Data_5 := RxData.5;
	BTFSC      _RxData+0, 5
	GOTO       L__main72
	BCF        RB5_bit+0, 5
	GOTO       L__main73
L__main72:
	BSF        RB5_bit+0, 5
L__main73:
;electronique_telecommande_002c_16f628.mpas,182 :: 		IO_Data_6 := RxData.6;
	BTFSC      _RxData+0, 6
	GOTO       L__main74
	BCF        RB6_bit+0, 6
	GOTO       L__main75
L__main74:
	BSF        RB6_bit+0, 6
L__main75:
;electronique_telecommande_002c_16f628.mpas,183 :: 		IO_Data_7 := RxData.7;
	BTFSC      _RxData+0, 7
	GOTO       L__main76
	BCF        RB7_bit+0, 7
	GOTO       L__main77
L__main76:
	BSF        RB7_bit+0, 7
L__main77:
;electronique_telecommande_002c_16f628.mpas,185 :: 		RxDataOld := RxData;
	MOVF       _RxData+0, 0
	MOVWF      _RxDataOld+0
;electronique_telecommande_002c_16f628.mpas,186 :: 		bDataReceived := false;   // reset int flag to allow detection of next byte
	CLRF       _bDataReceived+0
;electronique_telecommande_002c_16f628.mpas,187 :: 		end;
L__main36:
;electronique_telecommande_002c_16f628.mpas,188 :: 		end;
L__main34:
;electronique_telecommande_002c_16f628.mpas,189 :: 		end;
	GOTO       L__main24
;electronique_telecommande_002c_16f628.mpas,191 :: 		end.
	GOTO       $+0
; end of _main
